<html>
<head>
    <title>NodeJs AAD B2C Demo</title>
    <style>
        .hidden {
            visibility: hidden
        }

        .visible {
            visibility: visible
        }

        .response {
            border: solid;
            border-width: thin;
            background-color: azure;
            padding: 2px;
        }
    </style>
</head>
<body>
    <!-- bluebird only needed if this page needs to run on Internet Explorer -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bluebird/3.3.4/bluebird.min.js" class="pre"></script>
    <script src="https://secure.aadcdn.microsoftonline-p.com/lib/0.1.1/js/msal.min.js"></script>
    <script src="https://code.jquery.com/jquery-3.2.1.min.js" class="pre"></script>

    <h2>Get a Azure AD B2C token</h2>
    <div>
        <div id="label">Sign-in with Microsoft Azure AD B2C</div>
        <button id="auth" onclick="login()">Login</button>
        <button id="callApiButton" class="hidden" onclick="callApi()">Call Web API</button>
    </div>

    <pre class="response"></pre>

    <script class="pre">
        // The current application coordinates were pre-registered in a B2C tenant.
        var applicationConfig = {
            clientID: 'b415a7ca-5313-4010-88b0-b0653207744d',
            authority: "https://login.microsoftonline.com/tfp/PercyBearDomain.onmicrosoft.com/B2C_1_NodeJS_SiUpIn",
            b2cScopes: ["https://PercyBearDomain.onmicrosoft.com/b2capp/read"]
        };
    </script>

    <script>
        "use strict";
        var clientApplication = new Msal.UserAgentApplication(applicationConfig.clientID, applicationConfig.authority, function (errorDesc, token, error, tokenType) {
            // Called after loginRedirect or acquireTokenPopup
        });

        function login() {
         logMessage("Before loginPopup():\n");
                clientApplication.loginPopup(applicationConfig.b2cScopes).then(function (idToken) {
                logMessage("***********  Id Token Info ():\n");
                logMessage("idToken.slice(-40):\n" + idToken.slice(-40) + "\n\n");
                clientApplication.acquireTokenSilent(applicationConfig.b2cScopes).then(function (accessToken) {
                    logMessage("***********  Silent Access Token Info ():\n");
                    logMessage("accessToken.slice(-40):\n" + accessToken.slice(-40) + "\n\n");
                    updateUI();
                }, function (error) {
                    clientApplication.acquireTokenPopup(applicationConfig.b2cScopes).then(function (accessToken) {
                        logMessage("***********  Popup Access Token Info ():\n");
                        logMessage("accessToken.slice(-40):\n" + accessToken.slice(-40) + "\n\n");
                        updateUI();
                    }, function (error) {
                        logMessage("Error acquiring the popup:\n" + error);
                    });
                })
            }, function (error) {
                logMessage("Error during login:\n" + error);
            });
        }

        function updateUI() {
         logMessage("*********** Claim Info ():\n");
            var userName = clientApplication.getUser().name;
            logMessage("User '" + userName + "' logged-in");
            var authButton = document.getElementById('auth');
            authButton.innerHTML = 'logout';
            authButton.setAttribute('onclick', 'logout();');
            var label = document.getElementById('label');
            label.innerText = "Hello " + userName;
            var callWebApiButton = document.getElementById('callApiButton');
            callWebApiButton.setAttribute('class', 'visible');
        }

        function callApi() {
         logMessage("start callApi():\n");
            clientApplication.acquireTokenSilent(applicationConfig.b2cScopes).then(function (accessToken) {
                callApiWithAccessToken(accessToken);
            }, function (error) {
                clientApplication.acquireTokenPopup(applicationConfig.b2cScopes).then(function (accessToken) {
                    callApiWithAccessToken(accessToken);
                }, function (error) {
                    logMessage("Error acquiring the access token to call the Web api:\n" + error);
                });
            })
        }

        function callApiWithAccessloginToken(accessToken) {
         logMessage("start callApiWithAccessloginToken():\n");
            // Call the Web API with the AccessToken
            $.ajax({
                type: "GET",
                url: applicationConfig.webApi,
                headers: {
                    'Authorization': 'Bearer ' + accessToken,
                },
            }).done(function (data) {
                logMessage("Web APi returned:\n" + JSON.stringify(data));
            })
                .fail(function (jqXHR, textStatus) {
                    logMessage("Error calling the Web api:\n" + textStatus);
                })
        }

        function logout() {
         logMessage("start logout():\n");
            // Removes all sessions, need to call AAD endpoint to do full logout
            clientApplication.logout();
        }

        function logMessage(s) {
            document.body.querySelector('.response').appendChild(document.createTextNode('\n' + s));
        }

    </script>
</body>
</html>
